#include "udm_config.h"
#include "udm_common.h"
#include "udm_boolean.h"

/*
static int TOP(int s[],int num){
	if(num>0)return(s[num-1]);
	else	return(UDM_STACK_BOT);
}
static int PUSH(int s[],int * num,int arg){
	s[*num]=arg;(*num)++;return(0);
}
*/

#define TOP(s,num)      ((num>0)?(s[num-1]):(UDM_STACK_BOT))
#define PUSH(s,num,arg) {s[*(num)]=(arg);(*(num))++;}

static int POP(int s[],int * num){
	if(*num>0){	(*num)--;return(s[*num]);}
	else{return(UDM_STACK_BOT);}
}

/*
#define POP(s,num)      (((*(num))>0)?(s[--(*(num))]):(UDM_STACK_BOT))
*/

#define PUSHCMD(x,cmd)	PUSH(((x)->cstack),&((x)->ncstack),(cmd))
#define PUSHARG(x,arg)	PUSH(((x)->astack),&((x)->nastack),(arg))
#define POPCMD(x)	POP(((x)->cstack),&((x)->ncstack))
#define POPARG(x)	POP(((x)->astack),&((x)->nastack))
#define TOPCMD(x)	TOP(((x)->cstack),((x)->ncstack))
#define TOPARG(x)	TOP(((x)->astack),((x)->nastack))

/* Compute one operation */
static int perform(UDM_BOOLSTACK * s,int com){
	switch(com){
		case UDM_STACK_OR: PUSHARG(s,POPARG(s)||POPARG(s));break;
		case UDM_STACK_AND:PUSHARG(s,POPARG(s)&&POPARG(s));break;
		case UDM_STACK_NOT:PUSHARG(s,POPARG(s)?0:1);break;
	}
	return(0);
}

/* Main function to calculate items sequence */
int UdmCalcBoolItems(UDM_STACK_ITEM * items, int nitems){
	UDM_BOOLSTACK s;
	int i;
	/* Init stack */
	s.ncstack=0;s.nastack=0;
	for(i=0;i<nitems;i++){
		int c;

		switch(c=items[i].cmd){
			case UDM_STACK_RIGHT:
				/* Perform till LEFT bracket */
				while((TOPCMD(&s)!=UDM_STACK_LEFT)&&(TOPCMD(&s)!=UDM_STACK_BOT))
					perform(&s,POPCMD(&s));
				/* Pop LEFT bracket itself */
				if(TOPCMD(&s)==UDM_STACK_LEFT)
					POPCMD(&s);
				break;
			case UDM_STACK_OR:
			case UDM_STACK_AND:
				while(c<=TOPCMD(&s)){
					perform(&s,POPCMD(&s));
				}
				/* IMPORTANT! No break here!*/
				/*   ! */
			case UDM_STACK_LEFT:
			case UDM_STACK_NOT:
				PUSHCMD(&s,c);
				break;
			case UDM_STACK_WORD:
			default:
				PUSHARG(&s,items[i].arg);
				break;
		}
	}
	while(TOPCMD(&s)!=UDM_STACK_BOT){
		perform(&s,POPCMD(&s));
	}
	return(POPARG(&s));
}
