#include "udm_config.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "udm_common.h"
#include "udm_robots.h"
#include "udm_spell.h"
#include "udm_db.h"
#include "udm_utils.h"
#include "udm_mutex.h"


int UdmFreeRobots(UDM_ENV *Conf){
UDM_ROBOT *r;
	if(Conf->LockProc)Conf->LockProc(UDM_LOCK,UDM_LOCK_ROBOTS);
	if(!Conf->Robots){
		if(Conf->LockProc)Conf->LockProc(UDM_UNLOCK,UDM_LOCK_ROBOTS);
		return(0);
	}
	r=Conf->Robots;
	while(r->hostinfo){
		free(r->hostinfo);
		free(r->path);
		r++;
	}
	UDM_FREE(Conf->Robots);
	if(Conf->LockProc)Conf->LockProc(UDM_UNLOCK,UDM_LOCK_ROBOTS);
	return(0);
}
UDM_ROBOT * UdmFindRobots(UDM_ENV *Conf,char *url){
UDM_ROBOT * r;
	if(Conf->LockProc)Conf->LockProc(UDM_LOCK,UDM_LOCK_ROBOTS);
	if(Conf->Robots){
		r=Conf->Robots;
		while(r->hostinfo){
			if(strstr(url,r->hostinfo)&&strstr(url,r->path)){
				if(Conf->LockProc)Conf->LockProc(UDM_UNLOCK,UDM_LOCK_ROBOTS);
				return(r);
			}
			r++;
		}
	}
	if(Conf->LockProc)Conf->LockProc(UDM_UNLOCK,UDM_LOCK_ROBOTS);
	return(NULL);
}
int UdmParseRobots(UDM_AGENT *Indexer,char *content,char *hostinfo){
	int myrule=0;
	char *s,*e,*lt;

	UdmDeleteRobotsFromHost(Indexer,hostinfo);
	s=UdmGetToken(content,"\r\n",&lt);
	while(s){
		if(*s=='#'){
		}else
		if(!(UDM_STRNCASECMP(s,"User-Agent"))){
			if(strstr(s,UDM_USER_AGENT))myrule=1;
			else
			if(strstr(s,"*"))myrule=1;
			else
				myrule=0;
		}else
		if((!(UDM_STRNCASECMP(s,"Disallow")))&&(myrule)){
			if((e=strchr(s+9,'#')))*e=0;
			e=s+9;UDM_SKIP(e," \t");s=e;
			UDM_SKIPN(e," \t");*e=0;
			if(*s){
				if(IND_ERROR==UdmAddRobotsToHost(Indexer,hostinfo,s))
					return(IND_ERROR);
			}
		}
		s=UdmGetToken(NULL,"\n\r",&lt);
	}
	return(IND_OK);
}
